/* Generated by GOB (v2.0.15)   (do not edit directly) */



/*
    GnubVersion - Gnome interface to SubVersion
    Copyright (C) 2007  Karl E. Jorgensen <karl@jorgensen.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#ifndef __GNUBVERSION_THREADMESSAGE_H__
#define __GNUBVERSION_THREADMESSAGE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <glib.h>


typedef enum {
	MESSAGE_TYPE_PROGRESS,
	MESSAGE_TYPE_INFO,
	MESSAGE_TYPE_ERROR,
	MESSAGE_TYPE_ASK_USERNAME_PASSWORD,
	MESSAGE_TYPE_ASK_USERNAME,
	MESSAGE_TYPE_USERNAME_PASSWORD_RESPONSE,
	MESSAGE_TYPE_USERNAME_RESPONSE,
	MESSAGE_TYPE_CANCEL_RESPONSE,
	MESSAGE_TYPE_ASK_CERT,
	MESSAGE_TYPE_CERT_RESPONSE,
	MESSAGE_TYPE_BYE_SUCCESS,
	MESSAGE_TYPE_BYE_ERROR
} GnubVersionThreadMessageType;
#define GNUBVERSION_TYPE_THREADMESSAGE_TYPE gnubversion_threadmessage_type_get_type()
GType gnubversion_threadmessage_type_get_type (void);


typedef enum {
	CERT_RESPONSE_REJECT,
	CERT_RESPONSE_ACCEPT_TEMP,
	CERT_RESPONSE_ACCEPT_PERM
} GnubVersionThreadMessageResponse;
#define GNUBVERSION_TYPE_THREADMESSAGE_RESPONSE gnubversion_threadmessage_response_get_type()
GType gnubversion_threadmessage_response_get_type (void);


/*
 * Type checking and casting macros
 */
#define GNUBVERSION_TYPE_THREADMESSAGE	(gnubversion_threadmessage_get_type())
#define GNUBVERSION_THREADMESSAGE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gnubversion_threadmessage_get_type(), GnubVersionThreadMessage)
#define GNUBVERSION_THREADMESSAGE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), gnubversion_threadmessage_get_type(), GnubVersionThreadMessage const)
#define GNUBVERSION_THREADMESSAGE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), gnubversion_threadmessage_get_type(), GnubVersionThreadMessageClass)
#define GNUBVERSION_IS_THREADMESSAGE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), gnubversion_threadmessage_get_type ())

#define GNUBVERSION_THREADMESSAGE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), gnubversion_threadmessage_get_type(), GnubVersionThreadMessageClass)

/* Private structure type */
typedef struct _GnubVersionThreadMessagePrivate GnubVersionThreadMessagePrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_GNUBVERSION_THREADMESSAGE__
#define __TYPEDEF_GNUBVERSION_THREADMESSAGE__
typedef struct _GnubVersionThreadMessage GnubVersionThreadMessage;
#endif
struct _GnubVersionThreadMessage {
	GObject __parent__;
	/*< private >*/
	GnubVersionThreadMessagePrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _GnubVersionThreadMessageClass GnubVersionThreadMessageClass;
struct _GnubVersionThreadMessageClass {
	GObjectClass __parent__;
};


/*
 * Public methods
 */
GType	gnubversion_threadmessage_get_type	(void);
GnubVersionThreadMessageType 	gnubversion_threadmessage_get_message_type	(GnubVersionThreadMessage * self);
const gchar * 	gnubversion_threadmessage_get_info	(GnubVersionThreadMessage * self);
const GError * 	gnubversion_threadmessage_get_error	(GnubVersionThreadMessage * self);
gdouble 	gnubversion_threadmessage_get_progress	(GnubVersionThreadMessage * self);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_progress	(gdouble val);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_error	(const GError * error);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_info	(const char * fmt,
					...);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_bye_success	(const char * fmt,
					...);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_bye_error	(const GError * error);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_ask_username_password	(GAsyncQueue * response_queue,
					const char * realm,
					const char * username,
					gboolean may_save);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_username_password_response	(const char * username,
					const char * password,
					gboolean may_save);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_ask_username	(GAsyncQueue * response_queue,
					gboolean may_save);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_username_response	(const char * username,
					gboolean may_save);
GAsyncQueue * 	gnubversion_threadmessage_get_response_queue	(GnubVersionThreadMessage * self);
GString * 	gnubversion_threadmessage_get_realm	(GnubVersionThreadMessage * self);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_cancel_response	(void);
GString * 	gnubversion_threadmessage_get_username	(GnubVersionThreadMessage * self);
GString * 	gnubversion_threadmessage_get_password	(GnubVersionThreadMessage * self);
gboolean 	gnubversion_threadmessage_get_may_save	(GnubVersionThreadMessage * self);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_ask_cert	(GAsyncQueue * queue,
					const char * question,
					gboolean may_save);
const char * 	gnubversion_threadmessage_get_question	(GnubVersionThreadMessage * self);
GnubVersionThreadMessage * 	gnubversion_threadmessage_new_cert_response	(int cert_response);
int 	gnubversion_threadmessage_get_cert_response	(GnubVersionThreadMessage * self);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
